it-swarm.com.ru

Не удалось загрузить ресурс, поскольку политика безопасности транспорта приложений требует использования безопасного соединения

Я сталкиваюсь с проблемой, когда я обновил свой Xcode до 7.0 или iOS 9.0. Каким-то образом это начало давать мне озаглавленную ошибку

"Не удалось загрузить ресурс, так как политика безопасности транспорта приложений требует использования безопасного соединения"

Метод веб-сервиса:

-(void)ServiceCall:(NSString*)ServiceName :(NSString *)DataString
{
NSURLSessionConfiguration *sessionConfiguration = [NSURLSessionConfiguration defaultSessionConfiguration];
    [sessionConfiguration setAllowsCellularAccess:YES];
    [sessionConfiguration setHTTPAdditionalHeaders:@{ @"Accept" : @"application/json" }];
    NSURLSession *session = [NSURLSession sessionWithConfiguration:sessionConfiguration];

    NSURL *url = [NSURL URLWithString:[NSString stringWithFormat:@"%@",ServiceURL]];
    NSLog(@"URl %@%@",url,DataString);
    // Configure the Request
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
    [request setValue:[NSString stringWithFormat:@"%@=%@", strSessName, strSessVal] forHTTPHeaderField:@"Cookie"];
    request.HTTPBody = [DataString dataUsingEncoding:NSUTF8StringEncoding];
    request.HTTPMethod = @"Post";

    // post the request and handle response
    NSURLSessionDataTask *postDataTask = [session dataTaskWithRequest:request completionHandler:^(NSData *data, NSURLResponse *response, NSError *error)
                                          {
                                              // Handle the Response
                                              if(error)
                                              {
                                                  NSLog(@"%@",[NSString stringWithFormat:@"Connection failed: %@", [error description]]);

                                                  // Update the View
                                                  dispatch_async(dispatch_get_main_queue(), ^{

                                                      // Hide the Loader
                                                      [MBProgressHUD hideHUDForView:[[UIApplication sharedApplication] delegate].window animated:YES];


                                                  });
                                                  return;
                                              }
                                              NSArray * cookies = [[NSHTTPCookieStorage sharedHTTPCookieStorage] cookiesForURL:request.URL];
                                              for (NSHTTPCookie * cookie in cookies)
                                              {
                                                  NSLog(@"%@=%@", cookie.name, cookie.value);
                                                  strSessName=cookie.name;
                                                  strSessVal=cookie.value;

                                              }

                                              NSString *retVal = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
}];
[postDataTask resume];

}

Служба работает нормально для более ранних версий Xcode и предыдущих версий iOS. Но когда я обновился до Xcode 7.0, который находится на iOS 9.0, он начал вызывать у меня проблему, подобную следующей, когда я вызываю вышеуказанный метод веб-службы. Зарегистрированная ошибка, которую я получаю:

Ошибка подключения: ошибка Domain = NSURLErrorDomain Code = -1022 "Не удалось загрузить ресурс, поскольку политика безопасности транспорта приложений требует использования безопасного подключения". UserInfo = {NSUnderlyingError = 0x7fada0f31880 {Error Domain = kCFErrorDomainCFNetwork Code = -1022 "(null)"}, NSErrorFailingURLStringKey = MyServiceURL , NSErrorFailingURLKey = MyService, загруженный из-за нехватки ресурсов, MyService загружен, так как не может быть передан в службу поддержки; Политика безопасности требует использования безопасного соединения.}

Я пробовал следующие вопросы и ответы, но не получил никакого результата, есть ли какая-либо предварительная идея, как я могу устранить эту ошибку вызова службы?

  1. ресурс не может быть загружен ios9
  2. App Transport Security Xcode 7 beta 6
  3. https://stackoverflow.com/a/3260997
438
Manab Kumar Mal

Я решил это с добавлением ключа в info.plist. Шаги, которые я выполнил:

  1. Открыл файл info.plist цели моего проекта

  2. Добавлен ключ с именем NSAppTransportSecurity в качестве Dictionary.

  3. Добавил подключ с именем NSAllowsArbitraryLoads как Boolean и установил его значение на YES, как показано на следующем рисунке.

enter image description here

Очистите проект, и теперь все работает как обычно.

Ссылка: https://stackoverflow.com/a/3260997

РЕДАКТИРОВАТЬ: OR В исходный код файла info.plist мы можем добавить, что:

<key>NSAppTransportSecurity</key>
    <dict>
        <key>NSAllowsArbitraryLoads</key>
        <true/>
        <key>NSExceptionDomains</key>
        <dict>
            <key>yourdomain.com</key>
            <dict>
                <key>NSIncludesSubdomains</key>
                <true/>
                <key>NSThirdPartyExceptionRequiresForwardSecrecy</key>
                <false/>
            </dict>
       </dict>
  </dict>
854
Manab Kumar Mal

Имейте в виду, что использование NSAllowsArbitraryLoads = true в info.plist проекта позволяет небезопасно подключаться к любому серверу. Если вы хотите убедиться, что только через определенный домен доступен через незащищенное соединение, попробуйте следующее:

enter image description here

Или, как исходный код:

<key>NSAppTransportSecurity</key>
<dict>
    <key>NSExceptionDomains</key>
    <dict>
        <key>domain.com</key>
        <dict>
            <key>NSExceptionAllowsInsecureHTTPLoads</key>
            <true/>
            <key>NSIncludesSubdomains</key>
            <true/>
        </dict>
    </dict>
</dict>

Очистить и построить проект после редактирования.

244
Arjan

Безопасность транспорта обеспечивается в iOS 9.0 или более поздней версии, а также в OS X v10.11 и более поздней версии.

Поэтому по умолчанию только https звонки разрешены только в приложениях. Чтобы отключить App Transport Security, добавьте следующие строки в файл info.plist ...

<key>NSAppTransportSecurity</key>
  <dict>
    <key>NSAllowsArbitraryLoads</key>
    <true/>
  </dict>

Для получения дополнительной информации:
https://developer.Apple.com/library/content/documentation/General/Reference/InfoPlistKeyReference/Articles/CocoaKeys.html#//Apple_ref/doc/uid/TP40009251-SW знак равно

38
Teja Kumar Bethina

Для iOS 10.x и Swift 3.x [также поддерживаются следующие версии] просто добавьте следующие строки в "info.plist"

<key>NSAppTransportSecurity</key>
<dict>
    <key>NSAllowsArbitraryLoads</key>
    <true/>
</dict>
31
Mr. Bean

В Swift 4 Вы можете использовать

-> Перейти Info.plist

-> Нажмите плюс из списка свойств информации

-> Добавить параметры безопасности транспорта приложения в качестве словаря

-> Нажмите значок плюса Настройки безопасности транспорта приложения

-> Добавить Разрешить произвольные загрузки установить ДА

Ниже изображение выглядит

enter image description here

22
Enamul Haque

Я решил как файл plist.

Добавьте NSAppTransportSecurity: словарь.

Добавить подраздел с именем "NSAllowsArbitraryLoads" в качестве логического значения: ДА

enter image description here

21
Avinash651

Не удалось загрузить ресурс, поскольку политика безопасности транспорта приложений требует использования безопасного соединения, работающего в Swift 4.03.

Откройте ваш pList.info как исходный код и вставьте:

<key>NSAppTransportSecurity</key>
<dict>
    <key>NSAllowsArbitraryLoads</key>
    <true/>
</dict>
14
Keshav Gera

Если вы используете Xcode 8.0 и Swift 3.0 или 2.2

enter image description here

10
Anit Kumar

Из Apple документации

Если вы разрабатываете новое приложение, вы должны использовать исключительно HTTPS. Если у вас есть существующее приложение, вы должны использовать HTTPS настолько, насколько вы можете прямо сейчас, и составить план миграции остальной части вашего приложения как можно скорее. Кроме того, ваше общение через высокоуровневые API должно быть зашифровано с использованием TLS версии 1.2 с прямой секретностью. Если вы попытаетесь установить соединение, которое не соответствует этому требованию, выдается сообщение об ошибке. Если вашему приложению нужно отправить запрос в небезопасный домен, вы должны указать этот домен в файле Info.plist вашего приложения.

Чтобы обойти безопасность транспорта приложения:

<key>NSAppTransportSecurity</key>
<dict>
  <key>NSExceptionDomains</key>
  <dict>
    <key>yourserver.com</key>
    <dict>
      <!--Include to allow subdomains-->
      <key>NSIncludesSubdomains</key>
      <true/>
      <!--Include to allow HTTP requests-->
      <key>NSTemporaryExceptionAllowsInsecureHTTPLoads</key>
      <true/>
      <!--Include to specify minimum TLS version-->
      <key>NSTemporaryExceptionMinimumTLSVersion</key>
      <string>TLSv1.1</string>
    </dict>
  </dict>
</dict>

Разрешить все небезопасные домены

<key>NSAppTransportSecurity</key>
<dict>
  <!--Include to allow all connections (DANGER)-->
  <key>NSAllowsArbitraryLoads</key>
  <true/>
</dict>

Подробнее: Настройка исключений безопасности транспорта приложений в iOS 9 и OSX 10.11

9
Ashok R

Вам просто нужно использовать HTTPS, а не HTTP в вашем URL, и он будет работать

9
pierre23

В Xcode 7.1 и более поздних версиях (Swift 2.0)

enter image description here

9
A.G

Если вы не большой поклонник XML, просто добавьте тег ниже в ваш файл plist.

enter image description here

7
MrWaqasAhmed

iOS 9 (может) заставит разработчиков использовать App Transport Security исключительно. Я случайно услышал это где-то случайно, так что сам не знаю, правда ли это. Но я подозреваю это и пришел к такому выводу:

Приложение, работающее на iOS 9, больше не будет (возможно) подключаться к серверу Meteor без SSL.

Это означает, что запуск метеоритного запуска ios или запуск метеоритного ios-устройства (вероятно?) Больше не будет работать.

В info.plist приложения NSAppTransportSecurity [Dictionary] должен иметь ключ NSAllowsArbitraryLoads [Boolean], который должен быть установлен в YES, или Meteor должен скоро использовать https для своего localhost server.

5
Mahesh

Если вы используете Xcode 8.0 до 8.3.3 и Swift 2.2 до 3.0

В моем случае необходимо изменить URL http: // на https: // (если не работает то попробуй)

Add an App Transport Security Setting: Dictionary.
Add a NSAppTransportSecurity: Dictionary.
Add a NSExceptionDomains: Dictionary.
Add a yourdomain.com: Dictionary.  (Ex: stackoverflow.com)

Add Subkey named " NSIncludesSubdomains" as Boolean: YES
Add Subkey named " NSExceptionAllowsInsecureHTTPLoads" as Boolean: YES

enter image description here

4
Md Imran Choudhury

Откройте ваш pList.info как Исходный код и в нижней части перед </dict> добавьте следующий код,

 <!--By Passing-->
    <key>NSAppTransportSecurity</key>
    <dict>
        <key>NSExceptionDomains</key>
        <dict>
            <key>your.domain.com</key>
            <dict>
                <key>NSIncludesSubdomains</key>
                <true/>
                <key>NSTemporaryExceptionAllowsInsecureHTTPLoads</key>
                <true/>
                <key>NSTemporaryExceptionMinimumTLSVersion</key>
                <string>1.0</string>
                <key>NSTemporaryExceptionRequiresForwardSecrecy</key>
                <false/>
            </dict>
        </dict>
    </dict>
    <!--End Passing-->

И, наконец, измените your.domain.com на свой базовый URL. Благодарю.

3
Najam

Мне удалось решить это с помощью комбинации множества упомянутых вариантов. Я включу контрольный список всех вещей, которые я должен был сделать, чтобы заставить это работать.

Короче:

  1. Установите для NSAllowsArbitraryLoads значение true для моего расширения часов (не для моего приложения часов).
  2. Убедитесь, что я использовал https, а не http.

Шаг первый:

Во-первых, и наиболее очевидно, что мне пришлось добавить ключ NSAppTransportSecurity в качестве словаря в info.plist моего расширения для часов с подключом с именем NSAllowsArbitraryLoads в качестве логического значения true. Только установите это в расширении часов, а не в списке приложений часов. Хотя обратите внимание, что это разрешает все соединения и может быть небезопасным.

enter image description here

или же

<key>NSAppTransportSecurity</key>
<dict>
    <key>NSAllowsArbitraryLoads</key>
    <true/>
</dict>

Шаг второй:

Затем я должен был убедиться, что URL-адрес, который я пытался загрузить, был https, а не просто http. Для любых URL, которые все еще были http, я использовал:

Swift :

let newURLString = oldURLString.stringByReplacingOccurrencesOfString("http", withString: "https")

Obj-C:

NSString *newURLString = [oldURLString stringByReplacingOccurrencesOfString:@“http” withString:@“https”];

2
Gordonium

Убедитесь, что вы изменили правильный файл info.plist.

Это второй раз Я трачу время на эту проблему, потому что я не заметил, что меняю информацию. plist под MyProjectNameUITests.

2
Shefy Gur-ary

Я решил эту проблему в случае самодостаточного сервера синтаксического анализа, использующего сертификат, подписанный на один год, а не параметр "NSAllowsArbitraryLoads"

Parse Server, так как любой сервер node.js представляет общедоступный URL-адрес https , который вы должны указать. Например:

parse-server --appId --masterKey --publicServerURL https: //your.public.url/some_nodejs

Не стесняйтесь взглянуть на мой файлы конфигурации

0
CyrIng